CheckWin
;are all jewels cleared?
	LD HL,Gameboard
	LD A,(BoardSize2)		;nr of jewels
	LD B,A
	
CheckWin2
	LD A,(HL)
	OR A
	RET NZ					;existing jewel found,no level end
	INC HL
	DJNZ CheckWin2
	

	LD HL,18432+42
	LD DE,LevelClearTxt
	CALL TypeText
	
	CALL FinalSound
	CALL FinalSound
	CALL FinalSound
	LD B,100
	CALL Wait
	
	CALL IncreaseScore
	
	CALL ClearScreen_Effect
	
	LD HL,LevelNr
	INC (HL)
	LD A,5
	LD (Lives),A
		
	JP NewLevel
	
;--------------------------
CheckGiveUp	
	LD BC,64510
	IN A,(C)
	BIT 3,A					;R pressed?
	RET NZ					;no - finish
	
	CALL DrawBorder			;clear jewels
	
;set lives nr	
	LD A,(Lives)
	DEC A
	OR A
	JP Z,GameOver
	LD (Lives),A
	
	ADD A,30
	LD (LevelFailTxt+24),A 
	
	LD HL,18432+43
	LD DE,LevelFailTxt
	CALL TypeText
	CALL FinalSound
	LD B,100
	CALL Wait
	CALL ClearScreen_Effect
	JP NewLevel
	
;----------------------
CheckQuit
	LD BC,65278
	IN A,(C)
	BIT 2,A					;X pressed?
	RET NZ					;no - don't quit
	
	CALL ClearScreen_Effect	
	JP Start
	

;----------------------
IncreaseScore	
	CALL DrawBorder			;clear border
	
	
IncreaseScore2	
	HALT
	HALT
	HALT
	HALT
	
;type bonus	
	LD A,(Lives)
	ADD A,30
	LD (BonusText+8),A
	
	LD HL,18432+43
	LD DE,BonusText
	CALL TypeText
	
;type score
	LD A,(Score)
	LD B,100
	LD C,0
IncreaseScore3				;hundreds
	INC C
	SUB B
	JR NC,IncreaseScore3
	ADD A,B
	DEC C
	
	LD B,10
	LD D,0
IncreaseScore4				;tens
	INC D
	SUB B
	JR NC,IncreaseScore4
	ADD A,B
	DEC D
	LD E,A
	
	LD HL,ScoreText+8
	LD A,C
	ADD A,30
	LD (HL),A
	INC HL
	LD A,D
	ADD A,30
	LD (HL),A
	INC HL
	LD A,E
	ADD A,30
	LD (HL),A
	
	LD HL,18432+106
	LD DE,ScoreText
	CALL TypeText
	
	CALL SelectionSound
	
	LD HL,Score
	INC (HL)
	
	LD A,(Lives)
	DEC A
	LD (Lives),A
	CP 255
	JR NZ,IncreaseScore2	
	
	LD HL,Score
	DEC (HL)				;was increased one too much
	
	LD B,50
	CALL Wait
	RET	
	
;---------------------
GameOver
	CALL ClearScreen
	LD HL,18432+107
	LD DE,GameOverText
	CALL TypeText
	LD B,150
	CALL Wait
	JP Start

;---------------------
GameWin
	CALL ClearScreen
	LD HL,16384+164
	LD DE,WinText
	CALL TypeText
	
	LD HL,20480+45
	LD DE,EndingPic
	LD BC,256*5+6
	CALL DrawSprite
	
	CALL 49152	;music
	LD B,200
	CALL Wait
	JP Start
	